// R|WbgJ[Mo̓fvO 𑜓xŁifj@PIC32MX695F512Hp@by K.Tanaka
// 300~225hbgA256F
//
// tJ[bmp摜t@CiWindows`jSDJ[h珇ǂݍݕ\

// SDJ[hڑ|[g
// SPI DO RG8  (O)
// SPI DI RG7  (I)
// SPI CLKO RG6  (O)
// CS  RF3  (O)
// WE  RF1  (I)
// CD  RF0  (I)

#define DITHER //`ƃfBU

#include <plib.h>
#include "composite32mx695.h"
#include "FSIO.h"
#include <stdlib.h>

//OtNX^ with PLL (20{)
#pragma config FSRSSEL = PRIORITY_7
#pragma config FUSBIDIO = OFF
#pragma config FVBUSONIO = OFF
#pragma config FPLLIDIV = DIV_1
#pragma config FPLLMUL = MUL_20
#pragma config UPLLIDIV = DIV_1
#pragma config UPLLEN = OFF
#pragma config FPLLODIV = DIV_1
#pragma config FNOSC = PRIPLL
#pragma config FSOSCEN = OFF
#pragma config IESO = OFF
#pragma config POSCMOD = XT
#pragma config OSCIOFNC = OFF
#pragma config FPBDIV = DIV_1
#pragma config FCKSM = CSDCMD
#pragma config FWDTEN = OFF
#pragma config DEBUG = OFF
#pragma config PWP = OFF
#pragma config BWP = OFF
#pragma config CP = OFF

int main(void){
	SearchRec sr;
	FSFILE *fp;
	int i,j;
	unsigned char data[3*X_RES],*p;
	unsigned char c,cr,cg,cb;
	unsigned short r,cr1,cg1,cb1;
 

	/* |[g̏ݒ */
	TRISB = 0x0000;						// Sďo
	TRISC = 0x0000;						// Sďo
	TRISD = 0x0000;						// Sďo
	TRISE = 0x0000;						// Sďo
	TRISF = 0x0003;						// RF0,1͓
	TRISG = 0x008c;						// RG7͓́iRG2,3͓͐pj

	init_composite(); // rfINAA荞ݏAJ[rfIo͊Jn

	//J[pbgݒ [rrrgggbb]
	c=0;
	for(cr=0;cr<8;cr++){
		for(cg=0;cg<8;cg++){
			for(cb=0;cb<4;cb++){
				set_palette(c,cb*85,cr*36+cr/2,cg*36+cg/2);
				c++;
			}
		}
	}

	printstr(0,0,255,"Detecting SDCARD");
	while (!MDD_MediaDetect());
	printstr(0,1*8,255,"OK");

	// Initialize the library
	printstr(0,2*8,255,"Initializing File System");
	while (!FSInit());
	printstr(0,3*8,255,"OK");

	while(1){
		FindFirst("*.bmp",ATTR_MASK,&sr);
		do{
			fp=FSfopen(sr.filename,READ);
			if(fp==NULL){
				printstr(0,4*8,255,"Can't Open File:");
				printstr(17,4*8,255,sr.filename);
				while(1) asm("wait");//[v
			}
			FSfseek(fp,0x36,SEEK_SET);

//			stop_composite(); //SDJ[hǂݍݒɕ\~ꍇ

			for(i=0;i<Y_RES;i++){
				if(FSfread(data,3*X_RES,1,fp)!=1) break;
				p=data;
				for(j=0;j<X_RES;j++){
#ifdef DITHER
					r=(unsigned short)((float)rand()*32.0/RAND_MAX);
					cb1=(*p++)+r;
					if(cb1>255) cb1=255;
					cg1=(*p++)+r;
					if(cg1>255) cg1=255;
					cr1=(*p++)+r;
					if(cr1>255) cr1=255;
					c=((cb1&0xc0)>>6)+((cg1&0xe0)>>3)+(cr1&0xe0);
#else
					c=(*p++&0xc0)>>6;
					c+=(*p++&0xe0)>>3;
					c+=*p++&0xe0;
#endif
					pset(j,Y_RES-1-i,c);
				}
			}
			FSfclose(fp);

//			start_composite(); //\ĊJ

			drawcount=0;
			while(drawcount<60*10) asm("wait"); //10bEFCg
		}
		while(!FindNext(&sr));
	}
}
